(function(){
  function checkProperty(parent, property) {
    var prop_arr = property.split(".");
    var obj = parent;
    for(var i = 0; i<prop_arr.length; i++) {
      var item = prop_arr[i];
      if(obj[item]) {
        obj = obj[item];
      } else {
        return false;
      }
    }
    return true;
  }

  function setProperty(parent, key, property) {
    var prop_arr = key.split(".");
    if(!parent[prop_arr[0]]) {
      parent[prop_arr[0]] = {};
    }
    parent[prop_arr[0]][prop_arr[1]] = property;
  }

  function bindIfAbsent(func_name, fn) {
    if(!checkProperty(window, func_name)) {
      setProperty(window, func_name, fn);
    }
  }

  bindIfAbsent("js2Android4.phone", function(number) {
       AlipayJSBridge.call('wTel', {'number': number});
  });

  bindIfAbsent("js2Android2.getCurrentUser", function(callbackStr) {
    AlipayJSBridge.call('wUser', {},function(user){
      if(user) {
        window[callbackStr]('null',user.data);
      } else {
        window[callbackStr]('error','');
      }
    });
  });

  bindIfAbsent("js2Android3.getEnv", function(callbackStr) {
    AlipayJSBridge.call('wEnv', {},function(env){
      if(env) {
        window[callbackStr]('null',env.data);
      } else {
        window[callbackStr]('error','');
      }
    });
  });

  bindIfAbsent("js2Android1.downloadImage", function(url,callbackStr) {
    AlipayJSBridge.call('wDownload', {'url': url},function(){
      AlipayJSBridge.call('wToast',{  content: '下载成功',
      type: 'success'},function(result ){
        window[callbackStr]();
      })
    });
  });

  bindIfAbsent("js2Android.downloadImage", function(url) {
    AlipayJSBridge.call('wDownload', {'url': url},function(result){
    if(result.code != '500') {
          AlipayJSBridge.call('wToast',{  content: result.message,
          type: 'success'},function(result ){
          })
    } else {
              AlipayJSBridge.call('wToast',{  content: result.message,
              type: 'failure'},function(result ){
              })
    }
    });
  });

  bindIfAbsent("js2Android6.wechatPay", function(data) {
    data = JSON.parse(data);
    AlipayJSBridge.call('wWxPay', {
      'appId': data.appid,
      'partnerId':data.partnerid,
      'prepayId':data.prepayid,
      'package':data.package,
      'nonceStr':data.noncestr,
      'timeStamp':data.timestamp,
      'sign':data.sign
    },function(result){
      window[data.callback](result);
    });
  });

   document.addEventListener('wStringCallback',function(event){
        console.log(event);
        window[event.data.data.callback](event.data.data.data);
   },false);


  if(window.onShareWeixinTimeline || window.onShareWeixinFriend){
    AlipayJSBridge.call('wSetRight', {text:'分享'},function(result){
    window.__shareWXFunction = function (e) {
                                       AlipayJSBridge.call('wActionSheet', {
                                         list: ["分享朋友圈","分享微信"]
                                       }, function (data) {
                                         if(data.data.position == 0) {
                                           var json = JSON.parse(window.onShareWeixinTimeline());
                                           AlipayJSBridge.call('wShareWxTimeline', {
                                             title: json.title,
                                             link: json.link,
                                             description: json.desc,
                                             image: json.imgUrl});
                                         } else {
                                           var json = JSON.parse(window.onShareWeixinFriend());
                                           AlipayJSBridge.call('wShareWxSession', {
                                             title: json.title,
                                             link: json.link,
                                             description: json.desc,
                                             image: json.imgUrl});
                                         }
                                       });
                                   };
      document.addEventListener('wRightButtonClick', window.__shareWXFunction,false);
    });
  }


})();
