window.AlipayJSBridge || (function() {
  function checkProperty(parent, property) {
    var prop_arr = property.split(".");
    var obj = parent;
    for (var i = 0; i < prop_arr.length; i++) {
      var item = prop_arr[i];
      if (obj[item]) {
        obj = obj[item];
      } else {
        return false;
      }
    }
    return true;
  }

  function setProperty(parent, key, property) {
    var prop_arr = key.split(".");
    if (!parent[prop_arr[0]]) {
      parent[prop_arr[0]] = {};
    }
    parent[prop_arr[0]][prop_arr[1]] = property;
  }

  function getUrlParams(url) {
    var params = {};
    if (url.indexOf("?") != -1) {
        var urls = url.split("?");
        var arr = urls[1].split("&");
        for (var i = 0, l = arr.length; i < l; i++) {
          var a = arr[i].split("=");
          params[a[0]] = a[1];
        }
    }
    return params;
  }

  function bindIfAbsent(func_name, fn) {
    if (!checkProperty(window, func_name)) {
      setProperty(window, func_name, fn);
    }
  }

  AlipayJSBridge = window.AlipayJSBridge || {
    call: function(func, param, callback) {
      window.WosaiJSBridge && window.WosaiJSBridge.call(func, param, callback);
    }
  };

  bindIfAbsent("WosaiJSBridge.openURL", function(url, params, callback) {
      if ('string' !== typeof url) {
        return;
      }
      if (!params && typeof(params) != 'undefined' && params != 0) {
        params = {};
      } else if ('function' === typeof params) {
        callback = params;
        params = {};
      } else if (typeof params !== 'object') {
        params = {};
      }

      if (url.indexOf("?") != -1) {
          var urlParams = getUrlParams(url);
          console.log(JSON.stringify(urlParams));
          params = Object.assign(params, urlParams);
          url = url.slice(0, url.indexOf("?"));
      }

      WosaiJSBridge.call('sOpenURL', {
      	url: url,
      	params: params
      }, callback);
  });

  bindIfAbsent("js2Android4.phone", function(number) {
    AlipayJSBridge.call('wTel', {
      'number': number
    });
  });

  bindIfAbsent("js2Android2.getCurrentUser", function(callbackStr) {
    AlipayJSBridge.call('wUser', {}, function(user) {
      if (user) {
        window[callbackStr]('null', user.data);
      } else {
        window[callbackStr]('error', '');
      }
    });
  });

  bindIfAbsent("js2Android3.getEnv", function(callbackStr) {
    AlipayJSBridge.call('wEnv', {}, function(env) {
      if (env) {
        window[callbackStr]('null', env.data);
      } else {
        window[callbackStr]('error', '');
      }
    });
  });

  bindIfAbsent("js2Android1.downloadImage", function(url, callbackStr) {
    AlipayJSBridge.call('wDownload', {
      'url': url
    }, function() {
      AlipayJSBridge.call('wToast', {
        content: '下载成功',
        type: 'success'
      }, function(result) {
        window[callbackStr]();
      })
    });
  });

  bindIfAbsent("js2Android.downloadImage", function(url) {
    AlipayJSBridge.call('wDownload', {
      'url': url
    }, function(result) {
      if (result.code != '500') {
        AlipayJSBridge.call('wToast', {
          content: result.message,
          type: 'success'
        }, function(result) {})
      } else {
        AlipayJSBridge.call('wToast', {
          content: result.message,
          type: 'failure'
        }, function(result) {})
      }
    });
  });

  bindIfAbsent("js2Android6.wechatPay", function(data) {
    data = JSON.parse(data);
    AlipayJSBridge.call('wWxPay', {
      'appId': data.appid,
      'partnerId': data.partnerid,
      'prepayId': data.prepayid,
      'package': data.package,
      'nonceStr': data.noncestr,
      'timeStamp': data.timestamp,
      'sign': data.sign
    }, function(result) {
      window[data.callback](result);
    });
  });


  document.addEventListener('wStringCallback', function(event) {
    console.log(event);
    alert(JSON.stringify(event.detail));
    window[event.data.data.callback](event.data.data.data);
  }, false);


  if (window.onShareWeixinTimeline || window.onShareWeixinFriend) {
    AlipayJSBridge.call('wSetRight', {
      text: '分享'
    }, function(result) {
      window.__shareWXFunction = function(e) {
        AlipayJSBridge.call('wActionSheet', {
          list: ["分享朋友圈", "分享微信"]
        }, function(data) {
          if (data.data.position == 0) {
            var json = JSON.parse(window.onShareWeixinTimeline());
            AlipayJSBridge.call('wShareWxTimeline', {
              title: json.title,
              link: json.link,
              description: json.desc,
              image: json.imgUrl
            });
          } else {
            var json = JSON.parse(window.onShareWeixinFriend());
            AlipayJSBridge.call('wShareWxSession', {
              title: json.title,
              link: json.link,
              description: json.desc,
              image: json.imgUrl
            });
          }
        });
      };
      document.addEventListener('wRightButtonClick', window.__shareWXFunction, false);
    });
  }

  var readyEvent = document.createEvent('Events');
  readyEvent.initEvent('AlipayJSBridgeReady', !1, !1);
  var docAddEventListener = document.addEventListener;
  document.addEventListener = function(name, func) {
    if (name === readyEvent.type) {
      setTimeout(function() {
        func(readyEvent)
      }, 1);
    }
    docAddEventListener.apply(document, arguments);
  };
  document.dispatchEvent(readyEvent);
  console.log("load AlipayJSBridge dispatchEvent AlipayJSBridgeReady");

})();