var that;

// 添加监听
document.addEventListener("updateChart", this.updateChart);
document.addEventListener("updateToday", this.updateToday);

function updateChart(data) {
  that.updateNeatData(data);
  that.refreshChart();
}

function updateToday(amount) {
  // that.updateNeatDataByAppendTodayamount(amount);
  // that.refreshChart();
}

var app = new Vue({
  el: "#app",
  data: {
    colorRise: "#223C6E",
    colorDown: "#909EB4",
    charter: undefined,
    allzero: false,
    rawData: Array(),
    neatData: Array()
  },
  computed: {
    colors: function() {
      // console.log(JSON.stringify(this.neatData))
      let colors = Array();
      for (let i = 0, l = this.neatData.length; i < l; i++) {
        let color_ = this.colorRise;
        if (i > 0) {
          let amount_1 = this.neatData[i - 1].amount;
          let amount_2 = this.neatData[i].amount;
          color_ = amount_2 < amount_1 ? this.colorDown : this.colorRise;
        }
        colors.push(color_);
      }
      // console.log(colors);
      return colors;
    }
  },
  methods: {
    // 标准化数据
    updateNeatData: function(data) {
      this.rawData = data;
      this.neatData = _.map(this.rawData, daily_ => {
        return {
          amount: (daily_.amount > 0 ? 1 : 0) * daily_.amount * 0.01,
          date: daily_.date
        };
      });
      this.allzero = !_.some(this.neatData, daily_ => {
        return daily_.amount > 0;
      });
    },
    // 更新今天的值
    updateNeatDataByAppendTodayamount: function(amount) {
      this.rawData.shift();
      this.rawData.unshift(amount);
      this.updateNeatData(this.rawData);
    },
    // 刷新图标
    refreshChart: function() {
      this.charter
        .interval()
        .position("date*amount")
        .color("date", this.colors);
      this.charter.changeData(this.neatData);
    },
    // 绘制图表
    drawChart: function() {
      // 设置全局的外边距
      F2.Global.appendPadding = [4, 18, 4, 16];
      // 初始化绘图对象
      this.charter = new F2.Chart({
        id: "chart",
        pixelRatio: window.devicePixelRatio, // 指定分辨率
        plugins: {
          afterGeomDraw(chart) {
            // 当图标绘制完成之后，尝试通过这种形式告知webview已经加载完成
            window.location.href = "https://chart.render.success/";
          }
        }
      });
      // 设置刻度
      this.charter.source(this.diagram_data, {
        amount: {
          tickCount: 7,
          min: 0
        },
        date: {
          tickCount: 3
        }
      });

      // 创建图形语法，绘制柱状图，由 date 和 amount 两个属性决定图形位置，date 映射至 x 轴，amount 映射至 y 轴
      this.charter
        .interval()
        .position("date*amount")
        .color(this.colorRise);
      // 移除图例
      this.charter.legend(false);
      // 移除点击提示
      this.charter.tooltip(false);
      // 设置Y轴样式
      this.charter.axis("amount", {
        line: {
          lineWidth: 0,
          stroke: "#CCCCCC",
          top: false
        },
        label: {
          fill: "#4A4A4A",
          fontSize: 8
        }
      });
      // 设置X轴样式
      this.charter.axis("date", {
        line: {
          lineWidth: 0.5,
          stroke: "#CCCCCC",
          top: false
        },
        label: {
          fill: "#4A4A4A",
          fontSize: 8
        }
      });
      // 渲染图表
      this.charter.render();
    }
  },
  mounted() {
    that = this;
    this.$nextTick(function() {
      that.drawChart();
    });
  }
});
